routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Auth::routes();

Route::resource('users', \App\Http\Controllers\UserController::class)->only('index', 'show');

Route::resource('tasks', \App\Http\Controllers\TaskController::class)->except('create', 'index');

Route::resource('tags', \App\Http\Controllers\TagController::class)->except('show');
Route::get('/search/tag', [\App\Http\Controllers\TagController::class, 'search'])->name('tags.search');
Route::get('/tag_task/{task}', [\App\Http\Controllers\TagTaskController::class, 'index'])->name('tag_task.index');
Route::post('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'store'])->name('tag_task.store');
Route::delete('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'destroy'])->name('tag_task.destroy');


Route::get('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'addReadFriend']);
Route::delete('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteReadFriend']);
Route::get('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'addEditFriend']);
Route::delete('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteEditFriend']);

app/Models/Task.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Task extends Model
{
    use HasFactory;

    protected $fillable = ['user_id', 'picture', 'preview', 'task'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsToMany
     */
    public function tags(): BelongsToMany
    {
        return $this->belongsToMany(Tag::class);
    }
}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TaskRequest;
use App\Models\Task;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;
use Intervention\Image\Facades\Image;

class TaskController extends Controller
{
    public function __construct()
    {
        return $this->middleware('auth');
    }

    /**
     * @param Task $task
     * @return View|Factory|Application
     */
    public function show(Task $task): View|Factory|Application
    {
        return view('tasks.show', compact('task'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TaskRequest $request
     * @return JsonResponse
     */
    public function store(TaskRequest $request): JsonResponse
    {
        $data = $this->getArr($request);
        $task = new Task($data);
        $task->user_id = Auth::id();
        $task->save();

        return response()->json(
            [
                'task' => view('tasks.task', ['task' => $task])->render(),
            ],
            201
        );

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Task $task
     * @return Application|Factory|View
     * @throws AuthorizationException
     */
    public function edit(Task $task): View|Factory|Application
    {
        $this->authorize('update', $task);
        return view('tasks.edit', ['task' => $task]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param TaskRequest $request
     * @param Task $task
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(TaskRequest $request, Task $task): RedirectResponse
    {
        $this->authorize('update', $task);
        $data = $this->getArr($request);
        $task->update($data);
        return redirect()->route('users.show', ['user' => Auth::user()])->with('success', 'Successfully added');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Task $task
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function destroy(Task $task): RedirectResponse
    {
        $this->authorize('update', $task);
        $task->delete();
        return redirect()->back()->with('success', 'Successfully deleted');
    }

    /**
     * @param TaskRequest|Request $request
     * @return array
     */
    public function getArr(TaskRequest|Request $request): array
    {
        $data = $request->all();
        $file = $request->file('picture');
        if (!is_null($file)) {

            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;

            $image_name = md5($file->path()) . '.jpg';
            $resize = Image::make($file->path())->fit(150, 150)->encode('jpg');
            Storage::disk('public')->put('pictures/' . $image_name, $resize->__toString());
            $data['preview'] = 'pictures/' . $image_name;
        }
        return $data;
    }
}

resources/views/tasks/edit.blade.php
@extends('layouts.app')
@section('content')

    <form method="post" action="{{ route('tasks.update', ['task' => $task]) }}" enctype="multipart/form-data">
        @csrf
        @method('PUT')
        <div class="mb-3">
            <label for="task" class="form-label">Task</label>
            <input name="task" value="{{ $task->task }}" type="text"
                   class="form-control @if($errors->has('task')) is-invalid @endif" id="task">
            @error('task')
            <p class="text-danger">{{$message}}</p>
            @enderror


        </div>
        <div>
            <label for="picture" class="form-label">Picture</label>
            <input name="picture" class="form-control form-control-lg" id="picture" type="file">
        </div>
        <button type="submit" class="btn btn-primary">Update</button>
    </form>

@endsection

resources/views/tasks/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="card">
        @if ($task->picture)
            <img src="{{ asset('/storage/' . $task->picture ) }}" class="card-img-top" alt="#">
        @endif
        <div class="card-body">
            <p class="card-text">{{ $task->task }}</p>
            <a href="#" class="btn btn-primary">Go back</a>
        </div>
    </div>
@endsection

resources/views/tasks/task.blade.php
<tr>
    <td>{{ $task->id }}</td>
    <td class="w-50">{{ $task->task }}</td>

    @if($task->preview)
        <td><img src="{{ asset('/storage/' . $task->preview) }}" alt="#"></td>    </td>
    @else
        <td><img style="width: 150px; height: 150px"
                 src="https://thumbs.dreamstime.com/b/no-image-available-icon-photo-camera-flat-vector-illustration-132483141.jpg"
                 alt="#">
        </td>
    @endif


    <td>
        <div class="d-flex">
            @can('delete', $task)
                <form method="post" action="{{ route('tasks.destroy', ['task' => $task]) }}">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
            @endcan
            <a class="btn btn-outline-primary mx-1" href="{{route('tasks.show', ['task' => $task])}}">Show</a>
            @can('update', $task)
                <a class="btn btn-outline-warning" href="{{route('tasks.edit', ['task' => $task])}}">Edit</a>
                <a class="btn btn-outline-light mx-1" href="{{route('tag_task.index', ['task' => $task])}}">Add tag</a>
            @endcan
        </div>
    </td>
</tr>